pcl::PointXYZRGB Struct Reference
Module common

A point structure representing Euclidean xyz coordinates, and the RGB color. More...

`#include <pcl/impl/point_types.hpp>`

Inheritance diagram for pcl::PointXYZRGB:

## Public Member Functions

| PointXYZRGB (const _PointXYZRGB &p)
| PointXYZRGB ()
| PointXYZRGB (uint8_t _r, uint8_t _g, uint8_t _b)

## Friends

std::ostream & | operator<< (std::ostream &os, const PointXYZRGB &p)

## Additional Inherited Members

Public Attributes inherited from pcl::_PointXYZRGB
| PCL_ADD_POINT4D
| PCL_ADD_RGB

## Detailed Description

A point structure representing Euclidean xyz coordinates, and the RGB color.

Due to historical reasons (PCL was first developed as a ROS package), the RGB information is packed into an integer and casted to a float. This is something we wish to remove in the near future, but in the meantime, the following code snippet should help you pack and unpack RGB colors in your PointXYZRGB structure:

// pack r/g/b into rgb
uint8_t r = 255, g = 0, b = 0; // Example: Red color
uint32_t rgb = ((uint32_t)r << 16 | (uint32_t)g << 8 | (uint32_t)b);
p.rgb = *reinterpret_cast<float*>(&rgb);

To unpack the data into separate values, use:

PointXYZRGB p;
// unpack rgb into r/g/b
uint32_t rgb = *reinterpret_cast<int*>(&p.rgb);
uint8_t r = (rgb >> 16) & 0x0000ff;
uint8_t g = (rgb >> 8) & 0x0000ff;
uint8_t b = (rgb) & 0x0000ff;

Alternatively, from 1.1.0 onwards, you can use p.r, p.g, and p.b directly.

Definition at line 606 of file point_types.hpp.

## Constructor & Destructor Documentation

## PointXYZRGB() [1/3]

pcl::PointXYZRGB::PointXYZRGB | ( | const _PointXYZRGB & | p | ) |

inline

Definition at line 608 of file point_types.hpp.

## PointXYZRGB() [2/3]

pcl::PointXYZRGB::PointXYZRGB | ( |  | ) |

inline

Definition at line 614 of file point_types.hpp.

## PointXYZRGB() [3/3]

pcl::PointXYZRGB::PointXYZRGB | ( | uint8_t | _r,
|  | uint8_t | _g,
|  | uint8_t | _b
| ) |  |

inline

Definition at line 621 of file point_types.hpp.

References pcl::operator<<().

## Friends And Related Function Documentation

## operator<<

std::ostream& operator<< | ( | std::ostream & | os,
|  | const PointXYZRGB & | p
| ) |  |

friend

The documentation for this struct was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/common/include/pcl/impl/point_types.hpp